local myMod = ...

-- Apply building asset processor
myMod:registerAssetProcessor("models/stones.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/single_stones.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_logs.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/torch.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_cb.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/wooden_fence.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/front_building_2am.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/tombstone.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/grain_sack.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/stool.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/shield.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/bench.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/palm_tree.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
myMod:registerAssetProcessor("models/scalable_windows_1a.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register stone big
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_STONES_PART",
	Name = "DECO_STONES_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_STONES"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register stone small
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_STONES2_PART",
	Name = "DECO_STONES2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_STONES2"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register single stone big
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_SINGLESTONEBIG1_PART",
	Name = "DECO_SINGLESTONEBIG1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_SINGLESTONEBIG1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 3, 3 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 3 }
		}
	}
})

-- Register single stone middle
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_SINGLESTONEMIDDLE1_PART",
	Name = "DECO_SINGLESTONEMIDDLE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_SINGLESTONEMIDDLE1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 1.5, 1.5 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register single stone small
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_SINGLESTONESMALL1_PART",
	Name = "DECO_SINGLESTONESMALL1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_SINGLESTONESMALL1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 0.75, 0.75 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register pile of stones
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PILEOFSTONES1_PART",
	Name = "DECO_PILEOFSTONES1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PILEOFSTONES1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 1, 1 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 4 }
		}
	}
})

-- Register pile of polished stones
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PILEOFPOLISHEDSTONES1_PART",
	Name = "DECO_PILEOFPOLISHEDSTONES1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PILEOFPOLISHEDSTONES1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 1, 6 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "POLISHED_STONE", Quantity = 4 }
		}
	}
})

-- Register wood
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOOD_PART",
	Name = "DECO_WOOD_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOOD"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register wood plank
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOOD2_PART",
	Name = "DECO_WOOD2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOOD2"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register pile of wooden plank
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PILEOFWOODENPLANK1_PART",
	Name = "DECO_PILEOFWOODENPLANK1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PILEOFWOODENPLANK1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register torch
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TORCH_PART",
	Name = "DECO_TORCH_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TORCH"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register lamp
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_LAMP_PART",
	Name = "DECO_LAMP_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_LAMP"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register barrel
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_BARREL1_PART",
	Name = "DECO_BARREL1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_BARREL1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register crate
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_CRATE1_PART",
	Name = "DECO_CRATE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_CRATE1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register fence
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FENCE1_PART",
	Name = "DECO_FENCE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FENCE1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register pillory
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PILLORY1_PART",
	Name = "DECO_PILLORY1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PILLORY1"
	},
	--BuildingZone = { 2, 2 },
	BuildingZoneData = {
		Polygon = polygon.createRectangle({ 2, 2 })
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
})

-- Register front building
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FRONTBUILDING1_PART",
	Name = "DECO_FRONTBUILDING1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FRONTBUILDING1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register front building 2 sloped roof
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FRONTBUILDING2_PART",
	Name = "DECO_FRONTBUILDING2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FRONTBUILDING2"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register front building 2 sloped roof without left wall
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FRONTBUILDING3_PART",
	Name = "DECO_FRONTBUILDING3_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FRONTBUILDING3"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register front building 2 without left wall
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_FRONTBUILDING4_PART",
	Name = "DECO_FRONTBUILDING4_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_FRONTBUILDING4"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "PLANK", Quantity = 2 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register tombstone big
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TOMBSTONE1_PART",
	Name = "DECO_TOMBSTONE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TOMBSTONE1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register tombstone small
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TOMBSTONE2_PART",
	Name = "DECO_TOMBSTONE2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TOMBSTONE2"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register grain sack
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_GRAINSACK1_PART",
	Name = "DECO_GRAINSACK1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_GRAINSACK1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
		}
	}
})

-- Register wooden stool
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOODENSTOOL1_PART",
	Name = "DECO_WOODENSTOOL1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOODENSTOOL1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

-- Register wooden stool 2
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOODENSTOOL2_PART",
	Name = "DECO_WOODENSTOOL2_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOODENSTOOL2"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

-- Register wooden bench
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_WOODENBENCH1_PART",
	Name = "DECO_WOODENBENCH1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_WOODENBENCH1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register stone bench
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_STONEBENCH1_PART",
	Name = "DECO_STONEBENCH1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_STONEBENCH1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "STONE", Quantity = 2 }
		}
	}
})

-- Register shield
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_SHIELD1_PART",
	Name = "DECO_SHIELD1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_SHIELD1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register palm raft
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_PALM_RAFT1_PART",
	Name = "DECO_PALM_RAFT1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_PALM_RAFT1"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 3 },
			{ Resource = "TOOL", Quantity = 1 }
		}
	}
})

-- Register tree palm
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREE_PALM1_PART",
	Name = "DECO_TREE_PALM1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_DECO_TREE_PALM1"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree oak
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEOAK1_PART",
	Name = "DECO_TREEOAK1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_OAK"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree pine
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEPINE1_PART",
	Name = "DECO_TREEPINE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_PINE"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree poplar
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREEPOPLAR1_PART",
	Name = "DECO_TREEPOPLAR1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_POPLAR"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

-- Register tree sycamore
myMod:register({
	DataType = "BUILDING_PART",
	Id = "DECO_TREESYCAMORE1_PART",
	Name = "DECO_TREESYCAMORE1_NAME",
	Description = "",
	Category = "DECORATION",
	Mover = { 
		DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TREE_SYCAMORE"
	},
	--BuildingZone = { 1, 1 },
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD", Quantity = 1 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})

--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	myMod:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		Mover = { DataType = "BUILDING_PART_MOVER" },
		ConstructorData = { DataType = "BUILDING_CONSTRUCTOR_DEFAULT", CoreObjectPrefab = _nodePrefix .. "_PREFAB" }
	})
end

local defaultNodePrefixList = {
	"WINDOW_WS1_TOP",
	"WINDOW_WS1_TILING1",
	"WINDOW_WS2_TOP",
	"WINDOW_WS2_TILING1"
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList) do
	registerDefaultBuildingPart(nodePrefix)
end

--------------------------------------------------------------------------

-- Register the WS1 part
myMod:register({
	DataType = "BUILDING_PART",
	Id = "WINDOW_WS1_ROOT_PART",
	Name = "WINDOW_WS1_ROOT_NAME",
	Description = "WINDOW_WS1_ROOT_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "WINDOW_WS1_ROOT_PREFAB",
		EndPart = "WINDOW_WS1_TOP_PART",
		FillerList = {
			"WINDOW_WS1_TILING1_PART"
                },
		BasementFillerList = {
			"WINDOW_WS1_TILING1_PART"
       	},
		MinimumScale = 2,
		BasementScale = 1,
		IsVertical = true,
		IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 6 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})
-- Register the WS2 part
myMod:register({
	DataType = "BUILDING_PART",
	Id = "WINDOW_WS2_ROOT_PART",
	Name = "WINDOW_WS2_ROOT_NAME",
	Description = "WINDOW_WS2_ROOT_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "WINDOW_WS2_ROOT_PREFAB",
		EndPart = "WINDOW_WS2_TOP_PART",
		FillerList = {
			"WINDOW_WS2_TILING1_PART"
                },
		BasementFillerList = {
			"WINDOW_WS2_TILING1_PART"
       	},
		MinimumScale = 2,
		BasementScale = 1,
		IsVertical = true,
		IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 2 }
		},
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 6 },
			{ Resource = "WOOD", Quantity = 2 }
		}
	}
})